#pragma once
#include <iostream>

struct XY {
    float x;
    float y;

    XY() = default;
    XY(float _x , float _y): x(_x) , y(_y){}
};

std::ostream& operator<< (std::ostream& stream, const XY& point){
   return  stream << "(x: " << point.x << ", y:" << point.y << " )" ;
}


struct AABB{
    XY center;
    float halfDimension;
    
    AABB () = default;
    AABB (XY center, float halfDimension) : center(center), halfDimension(halfDimension) { }

    bool containsPoint (XY point )
    {

        if( point.x > (center.x + halfDimension))
            return false;

        if(point.x < (center.x - halfDimension))
            return false;

        if  (point.y > (center.y + halfDimension))
            return false;

        if (point.y < (center.y - halfDimension))
            return false;

        return true;
    }

    bool intersectsAABB(const AABB& other){
        return true;
    }


};


std::ostream& operator<< (std::ostream& stream, const AABB& bounds ){
    return stream << "[center "<<  bounds.center << ", half-dimension: " << bounds.halfDimension << " ]" ; 
} 